/*
Autor: Marius M.
Quelle: www.montisblog.de
Funktion: Dieses Programm erzeugt zwei Punkte auf einer 5x5 LED Matrix. Den einen Punkt kann man
steuern und den anderen, dessen Position zufällig ist, muss man fangen. 
*/


//In diesen beiden Arrays sind die Arduino Pins gespeichert, die eine Spalte bzw. 
//Zeile ansteuern.
const int Zeile[5]={
  11,9,8,6,3};
const int Spalte[5]={
  13,10,7,5,2};


//Mit den beiden folgenden Arrays kann festgestellt werden, welche Pins man ansteuern muss, um
//eine bestimmte LED zum leuchten zu bringen.
//Beispiel: LED 8 soll leuchten:
//Es müssen angesteuert werden Pin D5 (Spalte) und Pin D9(Zeile)
const int PosSpalte[25]={
  13,10,7,5,2,13,10,7,5,2,13,10,7,5,2,13,10,7,5,2,13,10,7,5,2};
const int PosZeile[25]={
  11,11,11,11,11,9,9,9,9,9,8,8,8,8,8,6,6,6,6,6,3,3,3,3,3};

int Pos;
int aWert;
int schalter = 0;
int ZufPos;
int PktPos = 12;
int n = 0;
int m = 0;

long ztime; //Zwischenzeit
long atime; //Alte Zeit
long ntime; //Neue Zeit

void setup()
{
  Serial.begin(9600);
  randomSeed(analogRead(A1));
  ZufPos = random(25);
  atime = millis(); 


//Alle benötigten Pins werden als Output deklariert.
  for (int i; i < 5; i++) {
    pinMode(Zeile[i], OUTPUT);
    pinMode(Spalte[i], OUTPUT);
  }


}

void loop()
{ 
  ntime = millis();
  ztime = ntime - atime;
  if (ztime > 150) {
    PktPos = Taster();
    atime = millis();  
  }
  
  if(ZufPos == PktPos){
  ZufPos = random(25);
  }
  
  delay(4);
  
if (m == 0) {
   m = 1;
   Pos = PktPos;
} else if (m == 1) {
   m = 0;
   Pos = ZufPos;
} 
   
  digitalWrite(PosSpalte[Pos], 0);

  for (int i; i < 5; i++) {
    if (PosSpalte[Pos] != Spalte[i]) {
      digitalWrite(Spalte[i], 1);
    }
  }


  digitalWrite(PosZeile[Pos], 1);

  for (int i; i < 5; i++) {
    if (PosZeile[Pos] != Zeile[i]) {
      digitalWrite(Zeile[i], 0);
    }
  }

  schalter = 0; 

  // delay(150);
}



//Methode um auszulesen, welcher Taster auf dem Steuerkreuz gedrückt wurde
int Taster() 
{
  aWert = analogRead(A0);
 // delay(10);
  aWert = analogRead(A0);
  n = 0;
 /* while (n == 0){
    if (analogRead(A0) == 0) {
      n = 1;
    }
  }*/

  if (aWert > 795 && aWert < 820) {
    schalter = 1;
    for (int i = 0; i < 5; i++) {
      if(PktPos > 0) {
        PktPos--;
      } 
      else {
        PktPos = 24;
      }
    }
  }

  if (aWert > 687 && aWert < 700) {
    schalter = 2;
    if (PktPos > 0){
      PktPos--;
    } 
    else {
      PktPos = 24;
    }
  }

  if (aWert > 700 && aWert < 725) {
    schalter = 3;
    PktPos = 12;
  }

  if (aWert > 725 && aWert < 745) {
    schalter = 4;
    if (PktPos < 24){
      PktPos++;
    } 
    else {
      PktPos = 0;
    }
  } 

  if (aWert > 745 && aWert < 770) {
    schalter = 5;
    for(int i = 0; i < 5; i++) {
      if(PktPos < 24){
        PktPos++;
      } 
      else {
        PktPos = 0;
      }
    }
  }  

 // Serial.println(schalter); 

  return PktPos;

}




